﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;

namespace Ueberpruefung
{
    class CheckLemmaEqualsTask : ElementChecker
    {
        private readonly SingleTask ownTask;
        public CheckLemmaEqualsTask(SingleTask ownTask) { this.ownTask = ownTask; }
        public override bool check(Element e)
        {
            if (e is Lemma l)
            {
                if (l.name == ownTask.name)
                {
                    bool FindVariableRenamings(List<Substitution> variableRenaming1, List<Substitution> variableRenaming2, bool swapped)
                    {
                        // 1. find a substitution
                        try
                        {
                            if (!swapped)
                            {
                                variableRenaming1.AddRange(CheckHelper.findSubstitution(l.eq.leftTree, ownTask.eq.leftTree ));
                                variableRenaming2.AddRange(CheckHelper.findSubstitution(l.eq.rightTree, ownTask.eq.rightTree));
                            }
                            else
                            {
                                variableRenaming1.AddRange(CheckHelper.findSubstitution(l.eq.leftTree, ownTask.eq.rightTree));
                                variableRenaming2.AddRange(CheckHelper.findSubstitution(l.eq.rightTree, ownTask.eq.leftTree));
                            }
                        }
                        catch (ArgumentNullException) { return false; }
                        // 2. check all substitutions are variable renamings with: isFixed(sub.variable) <-> isFixed(sub.tree.variable)
                        bool IsRenaming(List<Substitution> subs)
                        {
                            foreach (Substitution sub in subs)
                                if (sub.tree as TreeVariable == null
                                    ||  l.IsFixed(sub.variable) && !ownTask.IsFixed(((TreeVariable)sub.tree).variable)
                                    || !l.IsFixed(sub.variable) &&  ownTask.IsFixed(((TreeVariable)sub.tree).variable)
                                    ) return false;
                            return true;
                        }
                        return IsRenaming(variableRenaming1) && IsRenaming(variableRenaming2);
                    }
                    List<Substitution> variableRenaming1 = new List<Substitution>();
                    List<Substitution> variableRenaming2 = new List<Substitution>();
                    if (!FindVariableRenamings(variableRenaming1, variableRenaming2, false))
                    {
                        variableRenaming1.Clear(); variableRenaming2.Clear();
                        if (!FindVariableRenamings(variableRenaming1, variableRenaming2, true))
                            { l.errors.Add(new Error(22)); return false; }
                    }
                    if (CheckHelper.unionSubstitutions(variableRenaming1, variableRenaming2) == null)
                        { l.errors.Add(new Error(22)); return false; }
                    return true;
                }
                else return true;
            }
            else throw new InvalidOperationException();
        }
    }
}
